/* Generated by camel build tools - do NOT edit this file! */
/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.apache.camel.builder.endpoint.dsl;

import java.util.*;
import java.util.concurrent.*;
import java.util.function.*;
import java.util.stream.*;
import javax.annotation.processing.Generated;
import org.apache.camel.builder.EndpointConsumerBuilder;
import org.apache.camel.builder.EndpointProducerBuilder;
import org.apache.camel.builder.endpoint.AbstractEndpointBuilder;

/**
 * Receive files from SMB (Server Message Block) shares.
 * 
 * Generated by camel build tools - do NOT edit this file!
 */
@Generated("org.apache.camel.maven.packaging.EndpointDslMojo")
public interface SmbEndpointBuilderFactory {

    /**
     * Builder for endpoint consumers for the SMB component.
     */
    public interface SmbEndpointConsumerBuilder
            extends
                EndpointConsumerBuilder {
        default AdvancedSmbEndpointConsumerBuilder advanced() {
            return (AdvancedSmbEndpointConsumerBuilder) this;
        }
        /**
         * The path, within the share, to consume the files from.
         * 
         * The option is a: <code>java.lang.String</code> type.
         * 
         * Required: true
         * Group: common
         * 
         * @param path the value to set
         * @return the dsl builder
         */
        default SmbEndpointConsumerBuilder path(String path) {
            doSetProperty("path", path);
            return this;
        }
        /**
         * The search pattern used to list the files.
         * 
         * The option is a: <code>java.lang.String</code> type.
         * 
         * Default: *.txt
         * Group: common
         * 
         * @param searchPattern the value to set
         * @return the dsl builder
         */
        default SmbEndpointConsumerBuilder searchPattern(String searchPattern) {
            doSetProperty("searchPattern", searchPattern);
            return this;
        }
        /**
         * If a directory, will look for files in all the sub-directories as
         * well.
         * 
         * The option is a: <code>boolean</code> type.
         * 
         * Default: false
         * Group: consumer
         * 
         * @param recursive the value to set
         * @return the dsl builder
         */
        default SmbEndpointConsumerBuilder recursive(boolean recursive) {
            doSetProperty("recursive", recursive);
            return this;
        }
        /**
         * If a directory, will look for files in all the sub-directories as
         * well.
         * 
         * The option will be converted to a <code>boolean</code> type.
         * 
         * Default: false
         * Group: consumer
         * 
         * @param recursive the value to set
         * @return the dsl builder
         */
        default SmbEndpointConsumerBuilder recursive(String recursive) {
            doSetProperty("recursive", recursive);
            return this;
        }
        /**
         * If the polling consumer did not poll any files, you can enable this
         * option to send an empty message (no body) instead.
         * 
         * The option is a: <code>boolean</code> type.
         * 
         * Default: false
         * Group: consumer
         * 
         * @param sendEmptyMessageWhenIdle the value to set
         * @return the dsl builder
         */
        default SmbEndpointConsumerBuilder sendEmptyMessageWhenIdle(boolean sendEmptyMessageWhenIdle) {
            doSetProperty("sendEmptyMessageWhenIdle", sendEmptyMessageWhenIdle);
            return this;
        }
        /**
         * If the polling consumer did not poll any files, you can enable this
         * option to send an empty message (no body) instead.
         * 
         * The option will be converted to a <code>boolean</code> type.
         * 
         * Default: false
         * Group: consumer
         * 
         * @param sendEmptyMessageWhenIdle the value to set
         * @return the dsl builder
         */
        default SmbEndpointConsumerBuilder sendEmptyMessageWhenIdle(String sendEmptyMessageWhenIdle) {
            doSetProperty("sendEmptyMessageWhenIdle", sendEmptyMessageWhenIdle);
            return this;
        }
        /**
         * The number of subsequent error polls (failed due some error) that
         * should happen before the backoffMultipler should kick-in.
         * 
         * The option is a: <code>int</code> type.
         * 
         * Group: scheduler
         * 
         * @param backoffErrorThreshold the value to set
         * @return the dsl builder
         */
        default SmbEndpointConsumerBuilder backoffErrorThreshold(int backoffErrorThreshold) {
            doSetProperty("backoffErrorThreshold", backoffErrorThreshold);
            return this;
        }
        /**
         * The number of subsequent error polls (failed due some error) that
         * should happen before the backoffMultipler should kick-in.
         * 
         * The option will be converted to a <code>int</code> type.
         * 
         * Group: scheduler
         * 
         * @param backoffErrorThreshold the value to set
         * @return the dsl builder
         */
        default SmbEndpointConsumerBuilder backoffErrorThreshold(String backoffErrorThreshold) {
            doSetProperty("backoffErrorThreshold", backoffErrorThreshold);
            return this;
        }
        /**
         * The number of subsequent idle polls that should happen before the
         * backoffMultipler should kick-in.
         * 
         * The option is a: <code>int</code> type.
         * 
         * Group: scheduler
         * 
         * @param backoffIdleThreshold the value to set
         * @return the dsl builder
         */
        default SmbEndpointConsumerBuilder backoffIdleThreshold(int backoffIdleThreshold) {
            doSetProperty("backoffIdleThreshold", backoffIdleThreshold);
            return this;
        }
        /**
         * The number of subsequent idle polls that should happen before the
         * backoffMultipler should kick-in.
         * 
         * The option will be converted to a <code>int</code> type.
         * 
         * Group: scheduler
         * 
         * @param backoffIdleThreshold the value to set
         * @return the dsl builder
         */
        default SmbEndpointConsumerBuilder backoffIdleThreshold(String backoffIdleThreshold) {
            doSetProperty("backoffIdleThreshold", backoffIdleThreshold);
            return this;
        }
        /**
         * To let the scheduled polling consumer backoff if there has been a
         * number of subsequent idles/errors in a row. The multiplier is then
         * the number of polls that will be skipped before the next actual
         * attempt is happening again. When this option is in use then
         * backoffIdleThreshold and/or backoffErrorThreshold must also be
         * configured.
         * 
         * The option is a: <code>int</code> type.
         * 
         * Group: scheduler
         * 
         * @param backoffMultiplier the value to set
         * @return the dsl builder
         */
        default SmbEndpointConsumerBuilder backoffMultiplier(int backoffMultiplier) {
            doSetProperty("backoffMultiplier", backoffMultiplier);
            return this;
        }
        /**
         * To let the scheduled polling consumer backoff if there has been a
         * number of subsequent idles/errors in a row. The multiplier is then
         * the number of polls that will be skipped before the next actual
         * attempt is happening again. When this option is in use then
         * backoffIdleThreshold and/or backoffErrorThreshold must also be
         * configured.
         * 
         * The option will be converted to a <code>int</code> type.
         * 
         * Group: scheduler
         * 
         * @param backoffMultiplier the value to set
         * @return the dsl builder
         */
        default SmbEndpointConsumerBuilder backoffMultiplier(String backoffMultiplier) {
            doSetProperty("backoffMultiplier", backoffMultiplier);
            return this;
        }
        /**
         * Milliseconds before the next poll.
         * 
         * The option is a: <code>long</code> type.
         * 
         * Default: 500
         * Group: scheduler
         * 
         * @param delay the value to set
         * @return the dsl builder
         */
        default SmbEndpointConsumerBuilder delay(long delay) {
            doSetProperty("delay", delay);
            return this;
        }
        /**
         * Milliseconds before the next poll.
         * 
         * The option will be converted to a <code>long</code> type.
         * 
         * Default: 500
         * Group: scheduler
         * 
         * @param delay the value to set
         * @return the dsl builder
         */
        default SmbEndpointConsumerBuilder delay(String delay) {
            doSetProperty("delay", delay);
            return this;
        }
        /**
         * If greedy is enabled, then the ScheduledPollConsumer will run
         * immediately again, if the previous run polled 1 or more messages.
         * 
         * The option is a: <code>boolean</code> type.
         * 
         * Default: false
         * Group: scheduler
         * 
         * @param greedy the value to set
         * @return the dsl builder
         */
        default SmbEndpointConsumerBuilder greedy(boolean greedy) {
            doSetProperty("greedy", greedy);
            return this;
        }
        /**
         * If greedy is enabled, then the ScheduledPollConsumer will run
         * immediately again, if the previous run polled 1 or more messages.
         * 
         * The option will be converted to a <code>boolean</code> type.
         * 
         * Default: false
         * Group: scheduler
         * 
         * @param greedy the value to set
         * @return the dsl builder
         */
        default SmbEndpointConsumerBuilder greedy(String greedy) {
            doSetProperty("greedy", greedy);
            return this;
        }
        /**
         * Milliseconds before the first poll starts.
         * 
         * The option is a: <code>long</code> type.
         * 
         * Default: 1000
         * Group: scheduler
         * 
         * @param initialDelay the value to set
         * @return the dsl builder
         */
        default SmbEndpointConsumerBuilder initialDelay(long initialDelay) {
            doSetProperty("initialDelay", initialDelay);
            return this;
        }
        /**
         * Milliseconds before the first poll starts.
         * 
         * The option will be converted to a <code>long</code> type.
         * 
         * Default: 1000
         * Group: scheduler
         * 
         * @param initialDelay the value to set
         * @return the dsl builder
         */
        default SmbEndpointConsumerBuilder initialDelay(String initialDelay) {
            doSetProperty("initialDelay", initialDelay);
            return this;
        }
        /**
         * Specifies a maximum limit of number of fires. So if you set it to 1,
         * the scheduler will only fire once. If you set it to 5, it will only
         * fire five times. A value of zero or negative means fire forever.
         * 
         * The option is a: <code>long</code> type.
         * 
         * Default: 0
         * Group: scheduler
         * 
         * @param repeatCount the value to set
         * @return the dsl builder
         */
        default SmbEndpointConsumerBuilder repeatCount(long repeatCount) {
            doSetProperty("repeatCount", repeatCount);
            return this;
        }
        /**
         * Specifies a maximum limit of number of fires. So if you set it to 1,
         * the scheduler will only fire once. If you set it to 5, it will only
         * fire five times. A value of zero or negative means fire forever.
         * 
         * The option will be converted to a <code>long</code> type.
         * 
         * Default: 0
         * Group: scheduler
         * 
         * @param repeatCount the value to set
         * @return the dsl builder
         */
        default SmbEndpointConsumerBuilder repeatCount(String repeatCount) {
            doSetProperty("repeatCount", repeatCount);
            return this;
        }
        /**
         * The consumer logs a start/complete log line when it polls. This
         * option allows you to configure the logging level for that.
         * 
         * The option is a: <code>org.apache.camel.LoggingLevel</code> type.
         * 
         * Default: TRACE
         * Group: scheduler
         * 
         * @param runLoggingLevel the value to set
         * @return the dsl builder
         */
        default SmbEndpointConsumerBuilder runLoggingLevel(org.apache.camel.LoggingLevel runLoggingLevel) {
            doSetProperty("runLoggingLevel", runLoggingLevel);
            return this;
        }
        /**
         * The consumer logs a start/complete log line when it polls. This
         * option allows you to configure the logging level for that.
         * 
         * The option will be converted to a
         * <code>org.apache.camel.LoggingLevel</code> type.
         * 
         * Default: TRACE
         * Group: scheduler
         * 
         * @param runLoggingLevel the value to set
         * @return the dsl builder
         */
        default SmbEndpointConsumerBuilder runLoggingLevel(String runLoggingLevel) {
            doSetProperty("runLoggingLevel", runLoggingLevel);
            return this;
        }
        /**
         * Allows for configuring a custom/shared thread pool to use for the
         * consumer. By default each consumer has its own single threaded thread
         * pool.
         * 
         * The option is a:
         * <code>java.util.concurrent.ScheduledExecutorService</code> type.
         * 
         * Group: scheduler
         * 
         * @param scheduledExecutorService the value to set
         * @return the dsl builder
         */
        default SmbEndpointConsumerBuilder scheduledExecutorService(ScheduledExecutorService scheduledExecutorService) {
            doSetProperty("scheduledExecutorService", scheduledExecutorService);
            return this;
        }
        /**
         * Allows for configuring a custom/shared thread pool to use for the
         * consumer. By default each consumer has its own single threaded thread
         * pool.
         * 
         * The option will be converted to a
         * <code>java.util.concurrent.ScheduledExecutorService</code> type.
         * 
         * Group: scheduler
         * 
         * @param scheduledExecutorService the value to set
         * @return the dsl builder
         */
        default SmbEndpointConsumerBuilder scheduledExecutorService(String scheduledExecutorService) {
            doSetProperty("scheduledExecutorService", scheduledExecutorService);
            return this;
        }
        /**
         * To use a cron scheduler from either camel-spring or camel-quartz
         * component. Use value spring or quartz for built in scheduler.
         * 
         * The option is a: <code>java.lang.Object</code> type.
         * 
         * Default: none
         * Group: scheduler
         * 
         * @param scheduler the value to set
         * @return the dsl builder
         */
        default SmbEndpointConsumerBuilder scheduler(Object scheduler) {
            doSetProperty("scheduler", scheduler);
            return this;
        }
        /**
         * To use a cron scheduler from either camel-spring or camel-quartz
         * component. Use value spring or quartz for built in scheduler.
         * 
         * The option will be converted to a <code>java.lang.Object</code> type.
         * 
         * Default: none
         * Group: scheduler
         * 
         * @param scheduler the value to set
         * @return the dsl builder
         */
        default SmbEndpointConsumerBuilder scheduler(String scheduler) {
            doSetProperty("scheduler", scheduler);
            return this;
        }
        /**
         * To configure additional properties when using a custom scheduler or
         * any of the Quartz, Spring based scheduler.
         * 
         * The option is a: <code>java.util.Map&lt;java.lang.String,
         * java.lang.Object&gt;</code> type.
         * The option is multivalued, and you can use the
         * schedulerProperties(String, Object) method to add a value (call the
         * method multiple times to set more values).
         * 
         * Group: scheduler
         * 
         * @param key the option key
         * @param value the option value
         * @return the dsl builder
         */
        default SmbEndpointConsumerBuilder schedulerProperties(String key, Object value) {
            doSetMultiValueProperty("schedulerProperties", "scheduler." + key, value);
            return this;
        }
        /**
         * To configure additional properties when using a custom scheduler or
         * any of the Quartz, Spring based scheduler.
         * 
         * The option is a: <code>java.util.Map&lt;java.lang.String,
         * java.lang.Object&gt;</code> type.
         * The option is multivalued, and you can use the
         * schedulerProperties(String, Object) method to add a value (call the
         * method multiple times to set more values).
         * 
         * Group: scheduler
         * 
         * @param values the values
         * @return the dsl builder
         */
        default SmbEndpointConsumerBuilder schedulerProperties(Map values) {
            doSetMultiValueProperties("schedulerProperties", "scheduler.", values);
            return this;
        }
        /**
         * Whether the scheduler should be auto started.
         * 
         * The option is a: <code>boolean</code> type.
         * 
         * Default: true
         * Group: scheduler
         * 
         * @param startScheduler the value to set
         * @return the dsl builder
         */
        default SmbEndpointConsumerBuilder startScheduler(boolean startScheduler) {
            doSetProperty("startScheduler", startScheduler);
            return this;
        }
        /**
         * Whether the scheduler should be auto started.
         * 
         * The option will be converted to a <code>boolean</code> type.
         * 
         * Default: true
         * Group: scheduler
         * 
         * @param startScheduler the value to set
         * @return the dsl builder
         */
        default SmbEndpointConsumerBuilder startScheduler(String startScheduler) {
            doSetProperty("startScheduler", startScheduler);
            return this;
        }
        /**
         * Time unit for initialDelay and delay options.
         * 
         * The option is a: <code>java.util.concurrent.TimeUnit</code> type.
         * 
         * Default: MILLISECONDS
         * Group: scheduler
         * 
         * @param timeUnit the value to set
         * @return the dsl builder
         */
        default SmbEndpointConsumerBuilder timeUnit(TimeUnit timeUnit) {
            doSetProperty("timeUnit", timeUnit);
            return this;
        }
        /**
         * Time unit for initialDelay and delay options.
         * 
         * The option will be converted to a
         * <code>java.util.concurrent.TimeUnit</code> type.
         * 
         * Default: MILLISECONDS
         * Group: scheduler
         * 
         * @param timeUnit the value to set
         * @return the dsl builder
         */
        default SmbEndpointConsumerBuilder timeUnit(String timeUnit) {
            doSetProperty("timeUnit", timeUnit);
            return this;
        }
        /**
         * Controls if fixed delay or fixed rate is used. See
         * ScheduledExecutorService in JDK for details.
         * 
         * The option is a: <code>boolean</code> type.
         * 
         * Default: true
         * Group: scheduler
         * 
         * @param useFixedDelay the value to set
         * @return the dsl builder
         */
        default SmbEndpointConsumerBuilder useFixedDelay(boolean useFixedDelay) {
            doSetProperty("useFixedDelay", useFixedDelay);
            return this;
        }
        /**
         * Controls if fixed delay or fixed rate is used. See
         * ScheduledExecutorService in JDK for details.
         * 
         * The option will be converted to a <code>boolean</code> type.
         * 
         * Default: true
         * Group: scheduler
         * 
         * @param useFixedDelay the value to set
         * @return the dsl builder
         */
        default SmbEndpointConsumerBuilder useFixedDelay(String useFixedDelay) {
            doSetProperty("useFixedDelay", useFixedDelay);
            return this;
        }
        /**
         * The user domain.
         * 
         * The option is a: <code>java.lang.String</code> type.
         * 
         * Group: security
         * 
         * @param domain the value to set
         * @return the dsl builder
         */
        default SmbEndpointConsumerBuilder domain(String domain) {
            doSetProperty("domain", domain);
            return this;
        }
        /**
         * The password to access the share.
         * 
         * The option is a: <code>java.lang.String</code> type.
         * 
         * Group: security
         * 
         * @param password the value to set
         * @return the dsl builder
         */
        default SmbEndpointConsumerBuilder password(String password) {
            doSetProperty("password", password);
            return this;
        }
        /**
         * The username required to access the share.
         * 
         * The option is a: <code>java.lang.String</code> type.
         * 
         * Group: security
         * 
         * @param username the value to set
         * @return the dsl builder
         */
        default SmbEndpointConsumerBuilder username(String username) {
            doSetProperty("username", username);
            return this;
        }
    }

    /**
     * Advanced builder for endpoint consumers for the SMB component.
     */
    public interface AdvancedSmbEndpointConsumerBuilder
            extends
                EndpointConsumerBuilder {
        default SmbEndpointConsumerBuilder basic() {
            return (SmbEndpointConsumerBuilder) this;
        }
        /**
         * Allows for bridging the consumer to the Camel routing Error Handler,
         * which mean any exceptions (if possible) occurred while the Camel
         * consumer is trying to pickup incoming messages, or the likes, will
         * now be processed as a message and handled by the routing Error
         * Handler. Important: This is only possible if the 3rd party component
         * allows Camel to be alerted if an exception was thrown. Some
         * components handle this internally only, and therefore
         * bridgeErrorHandler is not possible. In other situations we may
         * improve the Camel component to hook into the 3rd party component and
         * make this possible for future releases. By default the consumer will
         * use the org.apache.camel.spi.ExceptionHandler to deal with
         * exceptions, that will be logged at WARN or ERROR level and ignored.
         * 
         * The option is a: <code>boolean</code> type.
         * 
         * Default: false
         * Group: consumer (advanced)
         * 
         * @param bridgeErrorHandler the value to set
         * @return the dsl builder
         */
        default AdvancedSmbEndpointConsumerBuilder bridgeErrorHandler(boolean bridgeErrorHandler) {
            doSetProperty("bridgeErrorHandler", bridgeErrorHandler);
            return this;
        }
        /**
         * Allows for bridging the consumer to the Camel routing Error Handler,
         * which mean any exceptions (if possible) occurred while the Camel
         * consumer is trying to pickup incoming messages, or the likes, will
         * now be processed as a message and handled by the routing Error
         * Handler. Important: This is only possible if the 3rd party component
         * allows Camel to be alerted if an exception was thrown. Some
         * components handle this internally only, and therefore
         * bridgeErrorHandler is not possible. In other situations we may
         * improve the Camel component to hook into the 3rd party component and
         * make this possible for future releases. By default the consumer will
         * use the org.apache.camel.spi.ExceptionHandler to deal with
         * exceptions, that will be logged at WARN or ERROR level and ignored.
         * 
         * The option will be converted to a <code>boolean</code> type.
         * 
         * Default: false
         * Group: consumer (advanced)
         * 
         * @param bridgeErrorHandler the value to set
         * @return the dsl builder
         */
        default AdvancedSmbEndpointConsumerBuilder bridgeErrorHandler(String bridgeErrorHandler) {
            doSetProperty("bridgeErrorHandler", bridgeErrorHandler);
            return this;
        }
        /**
         * To let the consumer use a custom ExceptionHandler. Notice if the
         * option bridgeErrorHandler is enabled then this option is not in use.
         * By default the consumer will deal with exceptions, that will be
         * logged at WARN or ERROR level and ignored.
         * 
         * The option is a: <code>org.apache.camel.spi.ExceptionHandler</code>
         * type.
         * 
         * Group: consumer (advanced)
         * 
         * @param exceptionHandler the value to set
         * @return the dsl builder
         */
        default AdvancedSmbEndpointConsumerBuilder exceptionHandler(org.apache.camel.spi.ExceptionHandler exceptionHandler) {
            doSetProperty("exceptionHandler", exceptionHandler);
            return this;
        }
        /**
         * To let the consumer use a custom ExceptionHandler. Notice if the
         * option bridgeErrorHandler is enabled then this option is not in use.
         * By default the consumer will deal with exceptions, that will be
         * logged at WARN or ERROR level and ignored.
         * 
         * The option will be converted to a
         * <code>org.apache.camel.spi.ExceptionHandler</code> type.
         * 
         * Group: consumer (advanced)
         * 
         * @param exceptionHandler the value to set
         * @return the dsl builder
         */
        default AdvancedSmbEndpointConsumerBuilder exceptionHandler(String exceptionHandler) {
            doSetProperty("exceptionHandler", exceptionHandler);
            return this;
        }
        /**
         * Sets the exchange pattern when the consumer creates an exchange.
         * 
         * The option is a: <code>org.apache.camel.ExchangePattern</code> type.
         * 
         * Group: consumer (advanced)
         * 
         * @param exchangePattern the value to set
         * @return the dsl builder
         */
        default AdvancedSmbEndpointConsumerBuilder exchangePattern(org.apache.camel.ExchangePattern exchangePattern) {
            doSetProperty("exchangePattern", exchangePattern);
            return this;
        }
        /**
         * Sets the exchange pattern when the consumer creates an exchange.
         * 
         * The option will be converted to a
         * <code>org.apache.camel.ExchangePattern</code> type.
         * 
         * Group: consumer (advanced)
         * 
         * @param exchangePattern the value to set
         * @return the dsl builder
         */
        default AdvancedSmbEndpointConsumerBuilder exchangePattern(String exchangePattern) {
            doSetProperty("exchangePattern", exchangePattern);
            return this;
        }
        /**
         * A pluggable org.apache.camel.PollingConsumerPollingStrategy allowing
         * you to provide your custom implementation to control error handling
         * usually occurred during the poll operation before an Exchange have
         * been created and being routed in Camel.
         * 
         * The option is a:
         * <code>org.apache.camel.spi.PollingConsumerPollStrategy</code> type.
         * 
         * Group: consumer (advanced)
         * 
         * @param pollStrategy the value to set
         * @return the dsl builder
         */
        default AdvancedSmbEndpointConsumerBuilder pollStrategy(org.apache.camel.spi.PollingConsumerPollStrategy pollStrategy) {
            doSetProperty("pollStrategy", pollStrategy);
            return this;
        }
        /**
         * A pluggable org.apache.camel.PollingConsumerPollingStrategy allowing
         * you to provide your custom implementation to control error handling
         * usually occurred during the poll operation before an Exchange have
         * been created and being routed in Camel.
         * 
         * The option will be converted to a
         * <code>org.apache.camel.spi.PollingConsumerPollStrategy</code> type.
         * 
         * Group: consumer (advanced)
         * 
         * @param pollStrategy the value to set
         * @return the dsl builder
         */
        default AdvancedSmbEndpointConsumerBuilder pollStrategy(String pollStrategy) {
            doSetProperty("pollStrategy", pollStrategy);
            return this;
        }
        /**
         * A pluggable repository org.apache.camel.spi.IdempotentRepository
         * which by default use MemoryIdempotentRepository if none is specified.
         * 
         * The option is a:
         * <code>org.apache.camel.spi.IdempotentRepository</code> type.
         * 
         * Group: advanced
         * 
         * @param idempotentRepository the value to set
         * @return the dsl builder
         */
        default AdvancedSmbEndpointConsumerBuilder idempotentRepository(org.apache.camel.spi.IdempotentRepository idempotentRepository) {
            doSetProperty("idempotentRepository", idempotentRepository);
            return this;
        }
        /**
         * A pluggable repository org.apache.camel.spi.IdempotentRepository
         * which by default use MemoryIdempotentRepository if none is specified.
         * 
         * The option will be converted to a
         * <code>org.apache.camel.spi.IdempotentRepository</code> type.
         * 
         * Group: advanced
         * 
         * @param idempotentRepository the value to set
         * @return the dsl builder
         */
        default AdvancedSmbEndpointConsumerBuilder idempotentRepository(String idempotentRepository) {
            doSetProperty("idempotentRepository", idempotentRepository);
            return this;
        }
        /**
         * An optional SMB client configuration, can be used to configure client
         * specific configurations, like timeouts.
         * 
         * The option is a: <code>com.hierynomus.smbj.SmbConfig</code> type.
         * 
         * Group: advanced
         * 
         * @param smbConfig the value to set
         * @return the dsl builder
         */
        default AdvancedSmbEndpointConsumerBuilder smbConfig(com.hierynomus.smbj.SmbConfig smbConfig) {
            doSetProperty("smbConfig", smbConfig);
            return this;
        }
        /**
         * An optional SMB client configuration, can be used to configure client
         * specific configurations, like timeouts.
         * 
         * The option will be converted to a
         * <code>com.hierynomus.smbj.SmbConfig</code> type.
         * 
         * Group: advanced
         * 
         * @param smbConfig the value to set
         * @return the dsl builder
         */
        default AdvancedSmbEndpointConsumerBuilder smbConfig(String smbConfig) {
            doSetProperty("smbConfig", smbConfig);
            return this;
        }
        /**
         * An optional SMB I/O bean to use to setup the file access attributes
         * when reading/writing a file.
         * 
         * The option is a:
         * <code>org.apache.camel.component.smb.SmbIOBean</code> type.
         * 
         * Group: advanced
         * 
         * @param smbIoBean the value to set
         * @return the dsl builder
         */
        default AdvancedSmbEndpointConsumerBuilder smbIoBean(org.apache.camel.component.smb.SmbIOBean smbIoBean) {
            doSetProperty("smbIoBean", smbIoBean);
            return this;
        }
        /**
         * An optional SMB I/O bean to use to setup the file access attributes
         * when reading/writing a file.
         * 
         * The option will be converted to a
         * <code>org.apache.camel.component.smb.SmbIOBean</code> type.
         * 
         * Group: advanced
         * 
         * @param smbIoBean the value to set
         * @return the dsl builder
         */
        default AdvancedSmbEndpointConsumerBuilder smbIoBean(String smbIoBean) {
            doSetProperty("smbIoBean", smbIoBean);
            return this;
        }
    }

    /**
     * Builder for endpoint producers for the SMB component.
     */
    public interface SmbEndpointProducerBuilder
            extends
                EndpointProducerBuilder {
        default AdvancedSmbEndpointProducerBuilder advanced() {
            return (AdvancedSmbEndpointProducerBuilder) this;
        }

        /**
         * The path, within the share, to consume the files from.
         * 
         * The option is a: <code>java.lang.String</code> type.
         * 
         * Required: true
         * Group: common
         * 
         * @param path the value to set
         * @return the dsl builder
         */
        default SmbEndpointProducerBuilder path(String path) {
            doSetProperty("path", path);
            return this;
        }
        /**
         * The search pattern used to list the files.
         * 
         * The option is a: <code>java.lang.String</code> type.
         * 
         * Default: *.txt
         * Group: common
         * 
         * @param searchPattern the value to set
         * @return the dsl builder
         */
        default SmbEndpointProducerBuilder searchPattern(String searchPattern) {
            doSetProperty("searchPattern", searchPattern);
            return this;
        }
        /**
         * Whether to create parent directory if it does not exist.
         * 
         * The option is a: <code>boolean</code> type.
         * 
         * Default: false
         * Group: producer
         * 
         * @param autoCreate the value to set
         * @return the dsl builder
         */
        default SmbEndpointProducerBuilder autoCreate(boolean autoCreate) {
            doSetProperty("autoCreate", autoCreate);
            return this;
        }
        /**
         * Whether to create parent directory if it does not exist.
         * 
         * The option will be converted to a <code>boolean</code> type.
         * 
         * Default: false
         * Group: producer
         * 
         * @param autoCreate the value to set
         * @return the dsl builder
         */
        default SmbEndpointProducerBuilder autoCreate(String autoCreate) {
            doSetProperty("autoCreate", autoCreate);
            return this;
        }
        /**
         * What action to take if the SMB file already exists.
         * 
         * The option is a:
         * <code>org.apache.camel.component.file.GenericFileExist</code> type.
         * 
         * Default: Ignore
         * Group: producer
         * 
         * @param fileExist the value to set
         * @return the dsl builder
         */
        default SmbEndpointProducerBuilder fileExist(org.apache.camel.component.file.GenericFileExist fileExist) {
            doSetProperty("fileExist", fileExist);
            return this;
        }
        /**
         * What action to take if the SMB file already exists.
         * 
         * The option will be converted to a
         * <code>org.apache.camel.component.file.GenericFileExist</code> type.
         * 
         * Default: Ignore
         * Group: producer
         * 
         * @param fileExist the value to set
         * @return the dsl builder
         */
        default SmbEndpointProducerBuilder fileExist(String fileExist) {
            doSetProperty("fileExist", fileExist);
            return this;
        }
        /**
         * Read buffer size when for file being produced.
         * 
         * The option is a: <code>int</code> type.
         * 
         * Default: 2048
         * Group: producer
         * 
         * @param readBufferSize the value to set
         * @return the dsl builder
         */
        default SmbEndpointProducerBuilder readBufferSize(int readBufferSize) {
            doSetProperty("readBufferSize", readBufferSize);
            return this;
        }
        /**
         * Read buffer size when for file being produced.
         * 
         * The option will be converted to a <code>int</code> type.
         * 
         * Default: 2048
         * Group: producer
         * 
         * @param readBufferSize the value to set
         * @return the dsl builder
         */
        default SmbEndpointProducerBuilder readBufferSize(String readBufferSize) {
            doSetProperty("readBufferSize", readBufferSize);
            return this;
        }
        /**
         * The user domain.
         * 
         * The option is a: <code>java.lang.String</code> type.
         * 
         * Group: security
         * 
         * @param domain the value to set
         * @return the dsl builder
         */
        default SmbEndpointProducerBuilder domain(String domain) {
            doSetProperty("domain", domain);
            return this;
        }
        /**
         * The password to access the share.
         * 
         * The option is a: <code>java.lang.String</code> type.
         * 
         * Group: security
         * 
         * @param password the value to set
         * @return the dsl builder
         */
        default SmbEndpointProducerBuilder password(String password) {
            doSetProperty("password", password);
            return this;
        }
        /**
         * The username required to access the share.
         * 
         * The option is a: <code>java.lang.String</code> type.
         * 
         * Group: security
         * 
         * @param username the value to set
         * @return the dsl builder
         */
        default SmbEndpointProducerBuilder username(String username) {
            doSetProperty("username", username);
            return this;
        }
    }

    /**
     * Advanced builder for endpoint producers for the SMB component.
     */
    public interface AdvancedSmbEndpointProducerBuilder extends EndpointProducerBuilder {
        default SmbEndpointProducerBuilder basic() {
            return (SmbEndpointProducerBuilder) this;
        }

        /**
         * Whether the producer should be started lazy (on the first message).
         * By starting lazy you can use this to allow CamelContext and routes to
         * startup in situations where a producer may otherwise fail during
         * starting and cause the route to fail being started. By deferring this
         * startup to be lazy then the startup failure can be handled during
         * routing messages via Camel's routing error handlers. Beware that when
         * the first message is processed then creating and starting the
         * producer may take a little time and prolong the total processing time
         * of the processing.
         * 
         * The option is a: <code>boolean</code> type.
         * 
         * Default: false
         * Group: producer (advanced)
         * 
         * @param lazyStartProducer the value to set
         * @return the dsl builder
         */
        default AdvancedSmbEndpointProducerBuilder lazyStartProducer(boolean lazyStartProducer) {
            doSetProperty("lazyStartProducer", lazyStartProducer);
            return this;
        }
        /**
         * Whether the producer should be started lazy (on the first message).
         * By starting lazy you can use this to allow CamelContext and routes to
         * startup in situations where a producer may otherwise fail during
         * starting and cause the route to fail being started. By deferring this
         * startup to be lazy then the startup failure can be handled during
         * routing messages via Camel's routing error handlers. Beware that when
         * the first message is processed then creating and starting the
         * producer may take a little time and prolong the total processing time
         * of the processing.
         * 
         * The option will be converted to a <code>boolean</code> type.
         * 
         * Default: false
         * Group: producer (advanced)
         * 
         * @param lazyStartProducer the value to set
         * @return the dsl builder
         */
        default AdvancedSmbEndpointProducerBuilder lazyStartProducer(String lazyStartProducer) {
            doSetProperty("lazyStartProducer", lazyStartProducer);
            return this;
        }
        /**
         * A pluggable repository org.apache.camel.spi.IdempotentRepository
         * which by default use MemoryIdempotentRepository if none is specified.
         * 
         * The option is a:
         * <code>org.apache.camel.spi.IdempotentRepository</code> type.
         * 
         * Group: advanced
         * 
         * @param idempotentRepository the value to set
         * @return the dsl builder
         */
        default AdvancedSmbEndpointProducerBuilder idempotentRepository(org.apache.camel.spi.IdempotentRepository idempotentRepository) {
            doSetProperty("idempotentRepository", idempotentRepository);
            return this;
        }
        /**
         * A pluggable repository org.apache.camel.spi.IdempotentRepository
         * which by default use MemoryIdempotentRepository if none is specified.
         * 
         * The option will be converted to a
         * <code>org.apache.camel.spi.IdempotentRepository</code> type.
         * 
         * Group: advanced
         * 
         * @param idempotentRepository the value to set
         * @return the dsl builder
         */
        default AdvancedSmbEndpointProducerBuilder idempotentRepository(String idempotentRepository) {
            doSetProperty("idempotentRepository", idempotentRepository);
            return this;
        }
        /**
         * An optional SMB client configuration, can be used to configure client
         * specific configurations, like timeouts.
         * 
         * The option is a: <code>com.hierynomus.smbj.SmbConfig</code> type.
         * 
         * Group: advanced
         * 
         * @param smbConfig the value to set
         * @return the dsl builder
         */
        default AdvancedSmbEndpointProducerBuilder smbConfig(com.hierynomus.smbj.SmbConfig smbConfig) {
            doSetProperty("smbConfig", smbConfig);
            return this;
        }
        /**
         * An optional SMB client configuration, can be used to configure client
         * specific configurations, like timeouts.
         * 
         * The option will be converted to a
         * <code>com.hierynomus.smbj.SmbConfig</code> type.
         * 
         * Group: advanced
         * 
         * @param smbConfig the value to set
         * @return the dsl builder
         */
        default AdvancedSmbEndpointProducerBuilder smbConfig(String smbConfig) {
            doSetProperty("smbConfig", smbConfig);
            return this;
        }
        /**
         * An optional SMB I/O bean to use to setup the file access attributes
         * when reading/writing a file.
         * 
         * The option is a:
         * <code>org.apache.camel.component.smb.SmbIOBean</code> type.
         * 
         * Group: advanced
         * 
         * @param smbIoBean the value to set
         * @return the dsl builder
         */
        default AdvancedSmbEndpointProducerBuilder smbIoBean(org.apache.camel.component.smb.SmbIOBean smbIoBean) {
            doSetProperty("smbIoBean", smbIoBean);
            return this;
        }
        /**
         * An optional SMB I/O bean to use to setup the file access attributes
         * when reading/writing a file.
         * 
         * The option will be converted to a
         * <code>org.apache.camel.component.smb.SmbIOBean</code> type.
         * 
         * Group: advanced
         * 
         * @param smbIoBean the value to set
         * @return the dsl builder
         */
        default AdvancedSmbEndpointProducerBuilder smbIoBean(String smbIoBean) {
            doSetProperty("smbIoBean", smbIoBean);
            return this;
        }
    }

    /**
     * Builder for endpoint for the SMB component.
     */
    public interface SmbEndpointBuilder
            extends
                SmbEndpointConsumerBuilder,
                SmbEndpointProducerBuilder {
        default AdvancedSmbEndpointBuilder advanced() {
            return (AdvancedSmbEndpointBuilder) this;
        }

        /**
         * The path, within the share, to consume the files from.
         * 
         * The option is a: <code>java.lang.String</code> type.
         * 
         * Required: true
         * Group: common
         * 
         * @param path the value to set
         * @return the dsl builder
         */
        default SmbEndpointBuilder path(String path) {
            doSetProperty("path", path);
            return this;
        }
        /**
         * The search pattern used to list the files.
         * 
         * The option is a: <code>java.lang.String</code> type.
         * 
         * Default: *.txt
         * Group: common
         * 
         * @param searchPattern the value to set
         * @return the dsl builder
         */
        default SmbEndpointBuilder searchPattern(String searchPattern) {
            doSetProperty("searchPattern", searchPattern);
            return this;
        }
        /**
         * The user domain.
         * 
         * The option is a: <code>java.lang.String</code> type.
         * 
         * Group: security
         * 
         * @param domain the value to set
         * @return the dsl builder
         */
        default SmbEndpointBuilder domain(String domain) {
            doSetProperty("domain", domain);
            return this;
        }
        /**
         * The password to access the share.
         * 
         * The option is a: <code>java.lang.String</code> type.
         * 
         * Group: security
         * 
         * @param password the value to set
         * @return the dsl builder
         */
        default SmbEndpointBuilder password(String password) {
            doSetProperty("password", password);
            return this;
        }
        /**
         * The username required to access the share.
         * 
         * The option is a: <code>java.lang.String</code> type.
         * 
         * Group: security
         * 
         * @param username the value to set
         * @return the dsl builder
         */
        default SmbEndpointBuilder username(String username) {
            doSetProperty("username", username);
            return this;
        }
    }

    /**
     * Advanced builder for endpoint for the SMB component.
     */
    public interface AdvancedSmbEndpointBuilder
            extends
                AdvancedSmbEndpointConsumerBuilder,
                AdvancedSmbEndpointProducerBuilder {
        default SmbEndpointBuilder basic() {
            return (SmbEndpointBuilder) this;
        }

        /**
         * A pluggable repository org.apache.camel.spi.IdempotentRepository
         * which by default use MemoryIdempotentRepository if none is specified.
         * 
         * The option is a:
         * <code>org.apache.camel.spi.IdempotentRepository</code> type.
         * 
         * Group: advanced
         * 
         * @param idempotentRepository the value to set
         * @return the dsl builder
         */
        default AdvancedSmbEndpointBuilder idempotentRepository(org.apache.camel.spi.IdempotentRepository idempotentRepository) {
            doSetProperty("idempotentRepository", idempotentRepository);
            return this;
        }
        /**
         * A pluggable repository org.apache.camel.spi.IdempotentRepository
         * which by default use MemoryIdempotentRepository if none is specified.
         * 
         * The option will be converted to a
         * <code>org.apache.camel.spi.IdempotentRepository</code> type.
         * 
         * Group: advanced
         * 
         * @param idempotentRepository the value to set
         * @return the dsl builder
         */
        default AdvancedSmbEndpointBuilder idempotentRepository(String idempotentRepository) {
            doSetProperty("idempotentRepository", idempotentRepository);
            return this;
        }
        /**
         * An optional SMB client configuration, can be used to configure client
         * specific configurations, like timeouts.
         * 
         * The option is a: <code>com.hierynomus.smbj.SmbConfig</code> type.
         * 
         * Group: advanced
         * 
         * @param smbConfig the value to set
         * @return the dsl builder
         */
        default AdvancedSmbEndpointBuilder smbConfig(com.hierynomus.smbj.SmbConfig smbConfig) {
            doSetProperty("smbConfig", smbConfig);
            return this;
        }
        /**
         * An optional SMB client configuration, can be used to configure client
         * specific configurations, like timeouts.
         * 
         * The option will be converted to a
         * <code>com.hierynomus.smbj.SmbConfig</code> type.
         * 
         * Group: advanced
         * 
         * @param smbConfig the value to set
         * @return the dsl builder
         */
        default AdvancedSmbEndpointBuilder smbConfig(String smbConfig) {
            doSetProperty("smbConfig", smbConfig);
            return this;
        }
        /**
         * An optional SMB I/O bean to use to setup the file access attributes
         * when reading/writing a file.
         * 
         * The option is a:
         * <code>org.apache.camel.component.smb.SmbIOBean</code> type.
         * 
         * Group: advanced
         * 
         * @param smbIoBean the value to set
         * @return the dsl builder
         */
        default AdvancedSmbEndpointBuilder smbIoBean(org.apache.camel.component.smb.SmbIOBean smbIoBean) {
            doSetProperty("smbIoBean", smbIoBean);
            return this;
        }
        /**
         * An optional SMB I/O bean to use to setup the file access attributes
         * when reading/writing a file.
         * 
         * The option will be converted to a
         * <code>org.apache.camel.component.smb.SmbIOBean</code> type.
         * 
         * Group: advanced
         * 
         * @param smbIoBean the value to set
         * @return the dsl builder
         */
        default AdvancedSmbEndpointBuilder smbIoBean(String smbIoBean) {
            doSetProperty("smbIoBean", smbIoBean);
            return this;
        }
    }

    public interface SmbBuilders {
        /**
         * SMB (camel-smb)
         * Receive files from SMB (Server Message Block) shares.
         * 
         * Category: file
         * Since: 4.3
         * Maven coordinates: org.apache.camel:camel-smb
         * 
         * Syntax: <code>smb:hostname:port/shareName</code>
         * 
         * Path parameter: hostname (required)
         * The share hostname or IP address
         * 
         * Path parameter: port
         * The share port number
         * Default value: 445
         * 
         * Path parameter: shareName (required)
         * The name of the share to connect to.
         * 
         * @param path hostname:port/shareName
         * @return the dsl builder
         */
        default SmbEndpointBuilder smb(String path) {
            return SmbEndpointBuilderFactory.endpointBuilder("smb", path);
        }
        /**
         * SMB (camel-smb)
         * Receive files from SMB (Server Message Block) shares.
         * 
         * Category: file
         * Since: 4.3
         * Maven coordinates: org.apache.camel:camel-smb
         * 
         * Syntax: <code>smb:hostname:port/shareName</code>
         * 
         * Path parameter: hostname (required)
         * The share hostname or IP address
         * 
         * Path parameter: port
         * The share port number
         * Default value: 445
         * 
         * Path parameter: shareName (required)
         * The name of the share to connect to.
         * 
         * @param componentName to use a custom component name for the endpoint
         * instead of the default name
         * @param path hostname:port/shareName
         * @return the dsl builder
         */
        default SmbEndpointBuilder smb(String componentName, String path) {
            return SmbEndpointBuilderFactory.endpointBuilder(componentName, path);
        }

    }
    static SmbEndpointBuilder endpointBuilder(String componentName, String path) {
        class SmbEndpointBuilderImpl extends AbstractEndpointBuilder implements SmbEndpointBuilder, AdvancedSmbEndpointBuilder {
            public SmbEndpointBuilderImpl(String path) {
                super(componentName, path);
            }
        }
        return new SmbEndpointBuilderImpl(path);
    }
}